/******************************************************************************/
/******************************************************************************/
/******************************************************************************/

function pMap() {
	this.m_keys = [];
	this.m_values = [];
	this.clear = function() {
		this.m_keys = [];
		this.m_values = [];
	};
	this.keyAt = function(i) {
		return this.m_keys[i];
	};
	this.valueAt = function(i) {
		return this.m_values[i];
	};
	this.get = function(p_key, p_default) {
		if (null==p_key)
			throw "Map key cannot be null";

		var i = this.m_keys.indexOf(p_key);
		if (i>=0)
			return this.m_values[i];
		return p_default;
	};
	this.put = function(p_key, p_value) {
		if (null==p_key)
			throw "Map key cannot be null";

		if (null==p_value)
			return this.remove(p_key);
		else {
			var i = this.m_keys.indexOf(p_key);
			if (i>=0) {
				var i_value = this.m_values[i];
				this.m_values[i] = p_value;
				return i_value;
			}
			else {
				this.m_keys[this.m_keys.length] = p_key;
				this.m_values[this.m_values.length] = p_value;
				return null;
			}
		}
	};
	this.remove = function(p_key) {
		if (null==p_key)
			throw "Map key cannot be null";

		var i = this.m_keys.indexOf(p_key);
		if (i>=0) {
			var i_value = this.m_values[i];

			this.m_keys.splice(i, 1);
			this.m_values.splice(i ,1);

			return i_value;
		}
		return null;
	};
	this.size = function() {
		return this.m_keys.length;
	};
}

/******************************************************************************/

var pDocument = {
	m_element_hide: new pMap(),
	hide: function(p_id) {
		if (null==p_id)
			return;
		var x = (typeof p_id=="string")? document.getElementById(p_id) : p_id;
		if (x==null)
			return;

		pDocument.m_element_hide.remove(p_id);
		if (x.style.display != "none")
			pDocument.m_element_hide.put(p_id, { element: x, display: x.style.display });

		x.style.display = "none";
	},
	show: function(p_id) {
		if (null==p_id)
			return;
		var x = (typeof p_id=="string")? document.getElementById(p_id) : p_id;
		if (x==null)
			return;

		var i_data = pDocument.m_element_hide.get(p_id, null);
		if (null!=i_data)
			x.style.display = i_data.display;
		else
			x.style.display = "block";
	},
	showInline: function(p_id) {
		if (null==p_id)
			return;
		var x = (typeof p_id=="string")? document.getElementById(p_id) : p_id;
		if (x==null)
			return;

		var i_data = pDocument.m_element_hide.get(p_id, null);
		if (null!=i_data)
			x.style.display = i_data.display;
		else
			x.style.display = "inline";
	},
	setClassName: function(p_id, p_class) {
		if (null==p_id)
			return;
		var x = (typeof p_id=="string")? document.getElementById(p_id) : p_id;
		if (x==null)
			return;

		x.className = p_class;
	}
};

/******************************************************************************/

// creates a global "addWheelListener" method
// example: addWheelListener( elem, function( e ) { console.log( e.deltaY ); e.preventDefault(); } );
(function(window,document) {

    var prefix = "", _addEventListener, onwheel, support;

    // detect event model
    if ( window.addEventListener ) {
        _addEventListener = "addEventListener";
    } else {
        _addEventListener = "attachEvent";
        prefix = "on";
    }

    // detect available wheel event
    support = "onwheel" in document.createElement("div") ? "wheel" : // Modern browsers support "wheel"
              document.onmousewheel !== undefined ? "mousewheel" : // Webkit and IE support at least "mousewheel"
              "DOMMouseScroll"; // let's assume that remaining browsers are older Firefox

    window.addWheelListener = function( elem, callback, useCapture ) {
        _addWheelListener( elem, support, callback, useCapture );

        // handle MozMousePixelScroll in older Firefox
        if( support == "DOMMouseScroll" ) {
            _addWheelListener( elem, "MozMousePixelScroll", callback, useCapture );
        }
    };

    function _addWheelListener( elem, eventName, callback, useCapture ) {
        elem[ _addEventListener ]( prefix + eventName, support == "wheel" ? callback : function( originalEvent ) {
            !originalEvent && ( originalEvent = window.event );

            // create a normalized event object
            var event = {
                // keep a ref to the original event object
                originalEvent: originalEvent,
                target: originalEvent.target || originalEvent.srcElement,
                type: "wheel",
                deltaMode: originalEvent.type == "MozMousePixelScroll" ? 0 : 1,
                deltaX: 0,
                deltaZ: 0,
                preventDefault: function() {
                    originalEvent.preventDefault ?
                        originalEvent.preventDefault() :
                        originalEvent.returnValue = false;
                }
            };

            // calculate deltaY (and deltaX) according to the event
            if ( support == "mousewheel" ) {
                event.deltaY = - 1/40 * originalEvent.wheelDelta;
                // Webkit also support wheelDeltaX
                originalEvent.wheelDeltaX && ( event.deltaX = - 1/40 * originalEvent.wheelDeltaX );
            } else {
                event.deltaY = originalEvent.detail;
            }

            // it's time to fire the callback
            return callback( event );

        }, useCapture || false );
    }

})(window,document);

/******************************************************************************/
/***  END OF FILE  ************************************************************/
/******************************************************************************/
