var pStyle = {
	m_parseWidth: function(p_width) {
		if (p_width == '')
			return 0;
		return parseInt(p_width.substring(0, p_width.indexOf('px')));
	},
	borderBottomWidth: function(p_element) {
		if (p_element.style.borderBottomWidth && p_element.style.borderBottomWidth!='')
			return pStyle.m_parseWidth(p_element.style.borderBottomWidth);
		return pStyle.m_parseWidth(window.getComputedStyle(p_element, null).getPropertyValue("border-bottom-width"));
	},
	borderLeftWidth: function(p_element) {
		if (p_element.style.borderLeftWidth && p_element.style.borderLeftWidth!='')
			return pStyle.m_parseWidth(p_element.style.borderLeftWidth);
		return pStyle.m_parseWidth(window.getComputedStyle(p_element, null).getPropertyValue("border-left-width"));
	},
	borderRightWidth: function(p_element) {
		if (p_element.style.borderRightWidth && p_element.style.borderRightWidth!='')
			return pStyle.m_parseWidth(p_element.style.borderRightWidth);
		return pStyle.m_parseWidth(window.getComputedStyle(p_element, null).getPropertyValue("border-right-width"));
	},
	borderTopWidth: function(p_element) {
		if (p_element.style.borderTopWidth && p_element.style.borderTopWidth!='')
			return pStyle.m_parseWidth(p_element.style.borderTopWidth);
		return pStyle.m_parseWidth(window.getComputedStyle(p_element, null).getPropertyValue("border-top-width"));
	},
	paddingBottomWidth: function(p_element) {
		if (p_element.style.paddingBottom && p_element.style.paddingBottom!='')
			return pStyle.m_parseWidth(p_element.style.paddingBottom);
		return pStyle.m_parseWidth(window.getComputedStyle(p_element, null).getPropertyValue("padding-bottom"));
	},
	paddingLeftWidth: function(p_element) {
		if (p_element.style.paddingLeft && p_element.style.paddingLeft!='')
			return pStyle.m_parseWidth(p_element.style.paddingLeft);
		return pStyle.m_parseWidth(window.getComputedStyle(p_element, null).getPropertyValue("padding-left"));
	},
	paddingTopWidth: function(p_element) {
		if (p_element.style.paddingTop && p_element.style.paddingTop!='')
			return pStyle.m_parseWidth(p_element.style.paddingTop);
		return pStyle.m_parseWidth(window.getComputedStyle(p_element, null).getPropertyValue("padding-top"));
	},
	paddingRightWidth: function(p_element) {
		if (p_element.style.paddingRight && p_element.style.paddingRight!='')
			return pStyle.m_parseWidth(p_element.style.paddingRight);
		return pStyle.m_parseWidth(window.getComputedStyle(p_element, null).getPropertyValue("padding-right"));
	},
	marginBottomWidth: function(p_element) {
		if (p_element.style.marginBottom && p_element.style.marginBottom!='')
			return pStyle.m_parseWidth(p_element.style.marginBottom);
		return pStyle.m_parseWidth(window.getComputedStyle(p_element, null).getPropertyValue("margin-bottom"));
	},
	marginTopWidth: function(p_element) {
		if (p_element.style.marginTop && p_element.style.marginTop!='')
			return pStyle.m_parseWidth(p_element.style.marginTop);
		return pStyle.m_parseWidth(window.getComputedStyle(p_element, null).getPropertyValue("margin-top"));
	},
	marginHeight: function(p_element) {
		var i_result = 0;
		var i_style = null;
		if (p_element.style.marginBottom && p_element.style.marginBottom!='')
			i_result += pStyle.m_parseWidth(p_element.style.marginBottom);
		else {
			i_style = window.getComputedStyle(p_element, null);
			i_result += pStyle.m_parseWidth(i_style.getPropertyValue("margin-bottom"));
		}

		if (p_element.style.marginTop && p_element.style.marginTop!='')
			i_result += pStyle.m_parseWidth(p_element.style.marginTop);
		else {
			if (null==i_style) i_style = window.getComputedStyle(p_element, null);
			i_result += pStyle.m_parseWidth(i_style.getPropertyValue("margin-top"));
		}
		return i_result;
	},
	marginLeftWidth: function(p_element) {
		if (p_element.style.marginLeft && p_element.style.marginLeft!='')
			return pStyle.m_parseWidth(p_element.style.marginLeft);
		return pStyle.m_parseWidth(window.getComputedStyle(p_element, null).getPropertyValue("margin-left"));
	},
	marginRightWidth: function(p_element) {
		if (p_element.style.marginRight && p_element.style.marginRight!='')
			return pStyle.m_parseWidth(p_element.style.marginRight);
		return pStyle.m_parseWidth(window.getComputedStyle(p_element, null).getPropertyValue("margin-right"));
	},
	marginWidth: function(p_element) {
		var i_result = 0;
		var i_style = null;
		if (p_element.style.marginRight && p_element.style.marginRight!='')
			i_result += pStyle.m_parseWidth(p_element.style.marginRight);
		else {
			i_style = window.getComputedStyle(p_element, null);
			i_result += pStyle.m_parseWidth(i_style.getPropertyValue("margin-right"));
		}

		if (p_element.style.marginLeft && p_element.style.marginLeft!='')
			i_result += pStyle.m_parseWidth(p_element.style.marginLeft);
		else {
			if (null==i_style) i_style = window.getComputedStyle(p_element, null);
			i_result += pStyle.m_parseWidth(i_style.getPropertyValue("margin-left"));
		}
		return i_result;
	},
	surroundHeight: function(p_element) {
		var i_result = 0;
		var i_style = null;

		if (p_element.style.paddingTop && p_element.style.paddingTop!='')
			i_result += pStyle.m_parseWidth(p_element.style.paddingTop);
		else {
			if (null==i_style) i_style = window.getComputedStyle(p_element, null);
			i_result += pStyle.m_parseWidth(i_style.getPropertyValue("padding-top"));
		}
		if (p_element.style.marginTop && p_element.style.marginTop!='')
			i_result += pStyle.m_parseWidth(p_element.style.marginTop);
		else {
			if (null==i_style) i_style = window.getComputedStyle(p_element, null);
			i_result += pStyle.m_parseWidth(i_style.getPropertyValue("margin-top"));
		}
		if (p_element.style.borderTop && p_element.style.borderTopWidth!='')
			i_result += pStyle.m_parseWidth(p_element.style.borderTopWidth);
		else {
			if (null==i_style) i_style = window.getComputedStyle(p_element, null);
			i_result += pStyle.m_parseWidth(i_style.getPropertyValue("border-top-width"));
		}

		if (p_element.style.paddingBottom && p_element.style.paddingBottom!='')
			i_result += pStyle.m_parseWidth(p_element.style.paddingBottom);
		else {
			if (null==i_style) i_style = window.getComputedStyle(p_element, null);
			i_result += pStyle.m_parseWidth(i_style.getPropertyValue("padding-bottom"));
		}
		if (p_element.style.marginBottom && p_element.style.marginBottom!='')
			i_result += pStyle.m_parseWidth(p_element.style.marginBottom);
		else {
			if (null==i_style) i_style = window.getComputedStyle(p_element, null);
			i_result += pStyle.m_parseWidth(i_style.getPropertyValue("margin-bottom"));
		}
		if (p_element.style.borderBottom && p_element.style.borderBottomWidth!='')
			i_result += pStyle.m_parseWidth(p_element.style.borderBottomWidth);
		else {
			if (null==i_style) i_style = window.getComputedStyle(p_element, null);
			i_result += pStyle.m_parseWidth(i_style.getPropertyValue("border-bottom-width"));
		}

		return i_result;
	},
	surroundTopHeight: function(p_element) {
		var i_result = 0;
		var i_style = null;

		if (p_element.style.paddingTop && p_element.style.paddingTop!='')
			i_result += pStyle.m_parseWidth(p_element.style.paddingTop);
		else {
			if (null==i_style) i_style = window.getComputedStyle(p_element, null);
			i_result += pStyle.m_parseWidth(i_style.getPropertyValue("padding-top"));
		}
		if (p_element.style.marginTop && p_element.style.marginTop!='')
			i_result += pStyle.m_parseWidth(p_element.style.marginTop);
		else {
			if (null==i_style) i_style = window.getComputedStyle(p_element, null);
			i_result += pStyle.m_parseWidth(i_style.getPropertyValue("margin-top"));
		}
		if (p_element.style.borderTop && p_element.style.borderTopWidth!='')
			i_result += pStyle.m_parseWidth(p_element.style.borderTopWidth);
		else {
			if (null==i_style) i_style = window.getComputedStyle(p_element, null);
			i_result += pStyle.m_parseWidth(i_style.getPropertyValue("border-top-width"));
		}

		return i_result;
	},
	surroundBottomHeight: function(p_element) {
		var i_result = 0;
		var i_style = null;

		if (p_element.style.paddingBottom && p_element.style.paddingBottom!='')
			i_result += pStyle.m_parseWidth(p_element.style.paddingBottom);
		else {
			if (null==i_style) i_style = window.getComputedStyle(p_element, null);
			i_result += pStyle.m_parseWidth(i_style.getPropertyValue("padding-bottom"));
		}
		if (p_element.style.marginBottom && p_element.style.marginBottom!='')
			i_result += pStyle.m_parseWidth(p_element.style.marginBottom);
		else {
			if (null==i_style) i_style = window.getComputedStyle(p_element, null);
			i_result += pStyle.m_parseWidth(i_style.getPropertyValue("margin-bottom"));
		}
		if (p_element.style.borderBottom && p_element.style.borderBottomWidth!='')
			i_result += pStyle.m_parseWidth(p_element.style.borderBottomWidth);
		else {
			if (null==i_style) i_style = window.getComputedStyle(p_element, null);
			i_result += pStyle.m_parseWidth(i_style.getPropertyValue("border-bottom-width"));
		}

		return i_result;
	}
};
